﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.Entity;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using SyncfusionMvcApplication1.Models;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;
using System.Web.Script.Services;
using SyncfusionMvcApplication1.Controllers;


namespace SyncfusionMvcApplication1
{
    public partial class KanbanController : Controller
    {
        private NORTHWNDEntities db = new NORTHWNDEntities();

        //
        // GET: /Kanban/
        public ActionResult KanbanFeatures()
        {
            return View();
        }
        public ActionResult GetData(Syncfusion.JavaScript.DataManager value)
       {
           var DataSource = db.Tasks.ToList();
           DataResult result1 = new DataResult();
           DataOperations operation = new DataOperations();
           result1.result = DataSource;
           result1.count = DataSource.AsQueryable().Count();
           if (value.Skip > 0)
               result1.result = operation.PerformSkip(result1.result, value.Skip);
           if (value.Take > 0)
               result1.result = operation.PerformTake(result1.result, value.Take);
           return Json(result1, JsonRequestBehavior.AllowGet);
       }

        //Edit multiple cards for priority drag and drop
        public ActionResult Crud(List<Task> changed, List<Task> added, List<Task> deleted)
        {
           

            ////Performing update operation
            if (changed != null && changed.Count() > 0)
            {
                foreach (var temp in changed)
                {
                    Task old = db.Tasks.Where(o => o.Id == temp.Id).SingleOrDefault();
                    if (old != null)
                    {
                        db.Entry(old).CurrentValues.SetValues(temp);
                    }
                }
            }    

            db.SaveChanges();
            var data = db.Tasks.ToList();
            if (data != null)
                return Json(new { result = data, success = "success" }, JsonRequestBehavior.AllowGet);
            else
                return Json(new { result = data, success = "failure" }, JsonRequestBehavior.AllowGet);
        }
    }
    public class DataResult
    {
        public IEnumerable result { get; set; }
        public int count { get; set; }
    }
}
